//--------------------------------------------------------------------//
// ȑgD}bv

var model;		// ȑgD}bvf[^f
var map;		// }bvg
var lp;			// wKp[^
var canvas;		// LoXvf
var context;	 	// ReLXg
var params;	 	// p[^\R{{bNX
var frameWindow;	// t[EBhE
var learnWindow;	// wKEBhE
var modal;		// [_EBhE
var req;		// Aj[ṼNGXg

var FRAME_WINDOW=0;	// t[EBhE
var LEARN_WINDOW=1;	// wKEBhE
var OP_WINDOW=2;	// wKEBhE

var FONT_SIZE=14;			// tHgTCY
var FONT=FONT_SIZE+"px 'Arial'";	// tHg
var FG_COLOR='#000000';			// OiF
var MAX_COLOR='#ff0000';		// ől̐F
var MIN_COLOR='#0000ff';		// ŏl̐F

// f[^
// fileName - f[^t@C
function initSom(fileName){
  model=new SomDataModel();
  lp=new LearningParameter();
  params=document.getElementById('params');
  frameWindow=new MapFrameWindow();
  learnWindow=new LearnWindow();
  initCanvas();
  if((fileName!==null) && (fileName!==undefined)){
    readServerFile(fileName);
  }
  modal=[document.getElementById('mapframe'),
      	 document.getElementById('learn'),
      	 document.getElementById('learnop')];
  draw();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('som');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  context=canvas.getContext('2d');
  context.strokeStyle=FG_COLOR;
  context.font=FONT;
  context.textBaseline='top';
  frameWindow.setHexMap();
}

// `悷
function draw(){
  context.clearRect(0,0,canvas.width,canvas.height);
  var param=params.selectedIndex;
  model.draw(param);
  context.fillStyle=FG_COLOR;
  var tx=canvas.height+10,ty=10;
  context.fillText('Step = '+model.step,tx,ty);
  ty+=2*FONT_SIZE;
  if(model.paramCount>0){
    context.fillText(model.labels[param],tx,ty);
    ty+=FONT_SIZE;
    context.fillStyle=MAX_COLOR;
    context.fillText('Max.:'+model.paramRange[param][1],tx,ty);
    ty+=FONT_SIZE;
    context.fillStyle=MIN_COLOR;
    context.fillText('Min.:'+model.paramRange[param][0],tx,ty);
  }
}

// [v֐
function loop(){
  model.next();
  draw();
  if(model.step<lp.stepCount){
    req=requestAnimationFrame(loop);
  }
  else{
    cancelAnimationFrame(req);
    hideModalWindow(OP_WINDOW);
  }
}

// t[EBhE\
function showFrameWindow(){
  showModalWindow(FRAME_WINDOW);
  frameWindow.stock();
}

// t[ݒ
function cancelMapFrame(){
  hideModalWindow(FRAME_WINDOW);
  frameWindow.reset();
}

// ȏiqt[ݒ肷
function setLineMap(){
  hideModalWindow(FRAME_WINDOW);
  frameWindow.setLineMap();
  draw();
}

// Sp`iqt[ݒ肷
function setGridMap(){
  hideModalWindow(FRAME_WINDOW);
  frameWindow.setGridMap();
  draw();
}

// Up`iqt[ݒ肷
function setHexMap(){
  hideModalWindow(FRAME_WINDOW);
  frameWindow.setHexMap();
  draw();
}

// wKEBhE\
function showLearnWindow(){
  showModalWindow(LEARN_WINDOW);
  learnWindow.stock();
}

// wKݒ
function cancelLearn(){
  hideModalWindow(LEARN_WINDOW);
  learnWindow.reset();
}

// wKJn
function startLearn(){
  hideModalWindow(LEARN_WINDOW);
  learnWindow.set();
  if(model.input.length>0){
    loop();
    showModalWindow(OP_WINDOW);
  }
}

// wKĊJ
function restartLearn(){
  if(model.input.length>0) loop();
}

// wK𒆒f
function stopLearn(){
  cancelAnimationFrame(req);
}

// wKI
function finishLearn(){
  cancelAnimationFrame(req);
  hideModalWindow(OP_WINDOW);
}

// p[^\R{{bNXݒ肷
function setViewParams(){
  if(params.hasChildNodes()){
    while(params.childNodes.length>0){
      params.removeChild(params.firstChild);
    }
  }
  for(var i=0;i<model.paramCount;i++){
    var opt=document.createElement('option');
    opt.value=i;
    opt.text=model.labels[i];
    params.appendChild(opt);
  }
  draw();
}

// [_EBhE\
// win - [_EBhẼCfbNX
function showModalWindow(win){
  modal[win].style.zIndex=4;
  modal[win].style.opacity=1;
}

// [_EBhE\ɂ
// win - [_EBhẼCfbNX
function hideModalWindow(win){
  modal[win].style.zIndex=1;
  modal[win].style.opacity=0;
}

// T[o[̐Mf[^t@Cǂݍ
// fileName - f[^t@C
function readServerFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readSignalData(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// [Jt@Cǂݍ
function readLocalFile(){
  var file=document.getElementById('localfile').files[0];
  var reader=new FileReader();
  reader.readAsText(file);
  reader.onload=function(e){
    readSignalData(reader.result.split(/\r?\n/g));
  };
}

// Mf[^ǂݍ
// s - f[^̃Xg
function readSignalData(s){
  model.clear();
  var count=Number.MAX_VALUE;
  var labels=s[0].trim().replace(/\t/g,' ').split(/\s+/);
  labels.shift();
  for(var i=1;i<s.length;i++){	// 1sڂ̓RgsƂēǂݔ΂
    var ss=s[i].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>1){
      var name=ss[0],data=[];
      count=Math.min(count,ss.length-1);
      for(var j=0;j<count;j++){
      	data[j]=parseFloat(ss[j+1]);
      }
      model.input.push(new Signal(name,data));
    }
  }
  model.paramCount=count;
  model.setParams(labels,count);
  model.normalize();
  model.initOutput();
  setViewParams();
}

// R^[}̐FԂ
// z - 0`1̒l
function contourColor(z){
  var r=0,g=0,b=0;
  if(z<=0){
    b=255;
  }
  else if(z<0.25){
    g=parseInt(1020*z);
    b=255;
  }
  else if(z<0.5){
    g=parseInt(306-204*z);
    b=parseInt(510-1020*z);
  }
  else if(z<0.75){
    r=parseInt(1020*z-510);
    g=parseInt(102+204*z);
  }
  else if(z<1){
    r=255;
    g=parseInt(1020*(1-z));
  }
  else{
    r=255;
  }
  return '#'+('00000'+((r<<16)|(g<<8)|b).toString(16)).slice(-6);
}

// p֌Wݒ肷
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// ȑgD}bvf[^f
var SomDataModel=function(){
  this.input=[];		// ͐M
  this.paramCount=0;		// M̃p[^
  this.labels=[];		// p[^̃x
  this.paramRange=[];		// p[^͈̔
  this.output=[];		// o͐M
  this.step=0;			// wKXebv
};

// f[^
SomDataModel.prototype.clear=function(){
  this.input.length=0;
  this.paramCount=0;
  this.labels.length=0;
  this.paramRange.length=0;
  this.output.length=0;
  this.step=0;
};

// M̃p[^ݒ肷
// labels - p[^̃x
// paramCount - M̃p[^
SomDataModel.prototype.setParams=function(labels,paramCount){
  this.paramCount=paramCount;
  for(var i=labels.length;i<paramCount;i++){
    labels[i]='Param'+(i+1);
  }
  this.labels=labels;
};

// f[^𐳋K
SomDataModel.prototype.normalize=function(){
  this.paramRange.length=0;
  if(this.input.length===0) return;
  for(var j=0;j<this.paramCount;j++){
    var pMax=this.input[0].data[j],pMin=this.input[0].data[j],i;
    for(i=1;i<this.input.length;i++){
      pMax=Math.max(pMax,this.input[i].data[j]);
      pMin=Math.min(pMin,this.input[i].data[j]);
    }
    this.paramRange[j]=[pMin,pMax];
    var coef=1;
    if(pMax>pMin) coef=1/(pMax-pMin);
    for(i=0;i<this.input.length;i++){
      this.input[i].data[j]=coef*(this.input[i].data[j]-pMin);
    }
  }
};

// o͐M
SomDataModel.prototype.initOutput=function(){
  this.step=0;
  this.output.length=0;
  for(var i=0;i<map.outputCount;i++){
    var data=[];
    for(var j=0;j<this.paramCount;j++){
      data[j]=Math.random();
    }
    this.output[i]=new Signal(null,data);
  }
  this.setWinner();
};

// ҁ͐Mɍł߂o͐Mݒ肷
SomDataModel.prototype.setWinner=function(){
  for(var i=0;i<this.input.length;i++){
    var is=this.input[i],vMin=this.matching(is,this.output[0]),w=0;
    for(var j=1;j<map.outputCount;j++){
      var v=this.matching(is,this.output[j]);
      if(v<vMin){
      	w=j;
      	vMin=v;
      }
    }
    this.input[i].winner=w;
  }
};

// M̈vl̂QԂ
SomDataModel.prototype.matching=function(s1,s2){
  var v=0;
  for(var i=0;i<this.paramCount;i++){
    var deu=s1.data[i]-s2.data[i];
    v+=deu*deu;
  }
  return v;
};

// wK̎̃Xebv̌vZ
SomDataModel.prototype.next=function(){
  for(var i=0;i<map.outputCount;i++){
    for(var j=0;j<this.paramCount;j++){
      var w=this.output[i].data[j],dw=0;
      for(var k=0;k<this.input.length;k++){
      	var ip=this.input[k];
      	dw+=map.neighbour(i,ip.winner,lp.sa)*(ip.data[j]-w);
      }
      this.output[i].data[j]=Math.min(Math.max(w+lp.eta*dw,0),1);
    }
  }
  this.step++;
  lp.sa*=lp.dsa;
  this.setWinner();
};

// `悷
// param - `悷p[^
SomDataModel.prototype.draw=function(param){
  var i;
  if((param>=0) && (this.output.length>0)){
    for(i=0;i<map.outputCount;i++){
      context.fillStyle=contourColor(this.output[i].data[param]);
      map.fill(context,i);
    }
  }
  if(this.input.length>0){
    context.fillStyle=FG_COLOR;
    var names=[];
    for(i=0;i<map.outputCount;i++){
      names[i]=[];
    }
    for(i=0;i<this.input.length;i++){
      names[this.input[i].winner].push(this.input[i].name);
    }
    for(i=0;i<map.outputCount;i++){
      map.drawLabel(context,names[i],i);
    }
  }
  for(i=0;i<map.outputCount;i++){
    map.stroke(context,i);
  }
};

//--------------------------------------------------------------------//
// Mf[^
// name - f[^
// data - f[^z
var Signal=function(name,data){
  this.name=name;
  this.data=data;
  this.winner=-1;	// ҁ̐Mɍł߂M
};

//--------------------------------------------------------------------//
// }bvg
// outputCount - o͓_
var MapFrame=function(outputCount){
  this.outputCount=outputCount;
  this.width=0;
  this.height=0;
};

// `͈͂ݒ肷
// width,height - `͈
MapFrame.prototype.setDrawRegion=function(width,height){
  this.width=width;
  this.height=height;
};

//--------------------------------------------------------------------//
// }bv
// outputCount - o͓_
var LineMap=function(outputCount){
  MapFrame.call(this,outputCount);
  this.unitWidth=0;	// jbg
};

// `͈͂ݒ肷
// width,height - `͈
LineMap.prototype.setDrawRegion=function(width,height){
  MapFrame.prototype.setDrawRegion.call(this,width,height);
  this.unitWidth=parseInt(width/this.outputCount);
};

// ߖT֐Ԃ
// p1,p2 - Q_̃CfbNX
// sa - ͈͂\W΍
LineMap.prototype.neighbour=function(p1,p2,sa){
  var dx=(p1-p2)/sa;
  return Math.exp(-0.5*dx*dx);
};

// }bvTCYԂ
LineMap.prototype.size=function(){
  return this.outputCount;
};

// jbgg`悷
// ctx - ReLXg
// index - jbg̃CfbNX
LineMap.prototype.stroke=function(ctx,index){
  ctx.strokeRect(this.unitWidth*index,0,this.unitWidth,this.height);
};

// jbghׂ
// ctx - ReLXg
// index - jbg̃CfbNX
LineMap.prototype.fill=function(ctx,index){
  ctx.fillRect(this.unitWidth*index,0,this.unitWidth,this.height);
};

// f[^x`悷
// ctx - ReLXg
// labels - f[^xz
// index - jbg̃CfbNX
LineMap.prototype.drawLabel=function(ctx,labels,index){
  var tx=this.unitWidth*index,ty=0;
  for(var i=0;i<labels.length;i++){
    ctx.fillText(labels[i],tx,ty);
    ty+=FONT_SIZE;
  }
};

//--------------------------------------------------------------------//
// Sp`iq}bv
// nx,ny - x,yiq
var GridMap=function(nx,ny){
  MapFrame.call(this,nx*ny);
  this.nx=nx;
  this.ny=ny;
  this.unitWidth=0;	// jbg
  this.unitHeight=0;	// jbg
};

// `͈͂ݒ肷
// width,height - `͈
GridMap.prototype.setDrawRegion=function(width,height){
  MapFrame.prototype.setDrawRegion.call(this,width,height);
  this.unitWidth=parseInt(width/this.nx);
  this.unitHeight=parseInt(height/this.ny);
};

// ߖT֐Ԃ
// p1,p2 - Q_̃CfbNX
// sa - ͈͂\W΍
GridMap.prototype.neighbour=function(p1,p2,sa){
  var dx=p1%this.nx-p2%this.nx;
  var dy=parseInt(p1/this.nx)-parseInt(p2/this.nx);
  return Math.exp(-0.5*(dx*dx+dy*dy)/(sa*sa));
};

// }bvTCYԂ
GridMap.prototype.size=function(){
  return Math.max(this.nx,this.ny);
};

// jbgg`悷
// ctx - ReLXg
// index - jbg̃CfbNX
GridMap.prototype.stroke=function(ctx,index){
  ctx.strokeRect(this.unitWidth*(index%this.nx),
      	      	 this.unitHeight*parseInt(index/this.nx),
      	      	 this.unitWidth,this.unitHeight);
};

// jbghׂ
// ctx - ReLXg
// index - jbg̃CfbNX
GridMap.prototype.fill=function(ctx,index){
  ctx.fillRect(this.unitWidth*(index%this.nx),
      	       this.unitHeight*parseInt(index/this.nx),
      	       this.unitWidth,this.unitHeight);
};

// f[^x`悷
// ctx - ReLXg
// labels - f[^xz
// index - jbg̃CfbNX
GridMap.prototype.drawLabel=function(ctx,labels,index){
  var tx=this.unitWidth*(index%this.nx);
  var ty=this.unitHeight*parseInt(index/this.nx);
  for(var i=0;i<labels.length;i++){
    ctx.fillText(labels[i],tx,ty);
    ty+=FONT_SIZE;
  }
};

//--------------------------------------------------------------------//
// Up`iq}bv
// nx,ny - x,yiq
var HexMap=function(nx,ny){
  MapFrame.call(this,nx*ny);
  this.nx=nx;
  this.ny=ny;
  this.unitWidth=0;	// jbg
  this.unitHeight=0;	// jbg
  this.x=[];		// Up`̒_W
  this.y=[];
};

// `͈͂ݒ肷
// width,height - `͈
HexMap.prototype.setDrawRegion=function(width,height){
  MapFrame.prototype.setDrawRegion.call(this,width,height);
  this.unitWidth=parseInt(width/(3*this.nx+1));
  this.unitHeight=parseInt(height/(2*this.ny+1));
  this.x=[4*this.unitWidth,3*this.unitWidth,this.unitWidth,
      	  0,this.unitWidth,3*this.unitWidth];
  this.y=[this.unitHeight,2*this.unitHeight,2*this.unitHeight,
      	  this.unitHeight,0,0];
};

// Up`̃jbg̈ʒuԂ
// index - jbg̃CfbNX
HexMap.prototype.hexPoint=function(index){
  var xd=index%this.nx,yd=parseInt(index/this.nx);
  return [3*xd,2*yd+xd%2];
};

// ߖT֐Ԃ
// p1,p2 - Q_̃CfbNX
// sa - ͈͂\W΍
HexMap.prototype.neighbour=function(p1,p2,sa){
  var hp1=this.hexPoint(p1),hp2=this.hexPoint(p2);
  var dx=hp1[0]-hp2[0],dy=hp1[1]-hp2[1];
  return Math.exp(-0.125*(dx*dx+dy*dy/3)/(sa*sa));
};

// }bvTCYԂ
HexMap.prototype.size=function(){
  return Math.max(this.nx,this.ny);
};

// jbgg`悷
// ctx - ReLXg
// index - jbg̃CfbNX
HexMap.prototype.stroke=function(ctx,index){
  this.drawHex(ctx,index);
  context.stroke();
};

// jbghׂ
// ctx - ReLXg
// index - jbg̃CfbNX
HexMap.prototype.fill=function(ctx,index){
  this.drawHex(ctx,index);
  context.fill();
};

// Up``悷
// ctx - ReLXg
// index - jbg̃CfbNX
HexMap.prototype.drawHex=function(ctx,index){
  var hp=this.hexPoint(index);
  var x0=this.unitWidth*hp[0],y0=this.unitHeight*hp[1];
  ctx.beginPath();
  ctx.moveTo(x0+this.x[0],y0+this.y[0]);
  for(var i=1;i<6;i++){
    ctx.lineTo(x0+this.x[i],y0+this.y[i]);
  }
  ctx.closePath();
};

// f[^x`悷
// ctx - ReLXg
// labels - f[^xz
// index - jbg̃CfbNX
HexMap.prototype.drawLabel=function(ctx,labels,index){
  var hp=this.hexPoint(index);
  var tx=this.unitWidth*hp[0],ty=this.unitHeight*hp[1];
  for(var i=0;i<labels.length;i++){
    ctx.fillText(labels[i],tx,ty);
    ty+=FONT_SIZE;
  }
};

//--------------------------------------------------------------------//
// wKp[^
var LearningParameter=function(){
  this.stepCount=0;	// Xebv
  this.eta=0;		// wK
  this.sa0=0;		// W΍
  this.sa=0;		// W΍
  this.dsa=0;		// W΍̕ω
};

// wKp[^ݒ肷
// stepCount - Xebv
// eta - wK
// sa0 - W΍
LearningParameter.prototype.set=function(stepCount,eta,sa0){
  this.stepCount=stepCount;
  this.eta=eta/model.input.length;
  this.sa0=sa0*map.size();
  this.sa=this.sa0;
  this.dsa=Math.exp(-2*this.sa0/this.stepCount);
};

//--------------------------------------------------------------------//
// t[EBhE
var MapFrameWindow=function(){
  this.gridX=document.getElementById('gridx');		// 
  this.gridY=document.getElementById('gridy');
  this.stock();
};

// ݒlXgbN
MapFrameWindow.prototype.stock=function(){
  this.stk=[this.gridX.value,this.gridY.value];
};

// XgbNlɖ߂
MapFrameWindow.prototype.reset=function(){
  this.gridX.value=this.stk[0];
  this.gridY.value=this.stk[1];
};

// ȏiqt[ݒ肷
MapFrameWindow.prototype.setLineMap=function(){
  map=new LineMap(parseInt(this.gridX.value));
  map.setDrawRegion(canvas.height,canvas.height);
  model.initOutput();
};

// Sp`iqt[ݒ肷
MapFrameWindow.prototype.setGridMap=function(){
  map=new GridMap(parseInt(this.gridX.value),
      	      	  parseInt(this.gridY.value));
  map.setDrawRegion(canvas.height,canvas.height);
  model.initOutput();
};

// Up`iqt[ݒ肷
MapFrameWindow.prototype.setHexMap=function(){
  map=new HexMap(parseInt(this.gridX.value),
      	      	 parseInt(this.gridY.value));
  map.setDrawRegion(canvas.height,canvas.height);
  model.initOutput();
};

//--------------------------------------------------------------------//
// wKEBhE
var LearnWindow=function(){
  this.stepCount=document.getElementById('stepcount');	// Xebv
  this.eta=document.getElementById('eta');		// wK
  this.sa0=document.getElementById('sa0');		// W΍
  this.stock();
};

// ݒlXgbN
LearnWindow.prototype.stock=function(){
  this.stk=[this.stepCount.value,this.eta.value,this.sa0.value];
};

// XgbNlɖ߂
LearnWindow.prototype.reset=function(){
  this.stepCount.value=this.stk[0];
  this.eta.value=this.stk[1];
  this.sa0.value=this.stk[2];
};

// wKp[^ݒ肷
LearnWindow.prototype.set=function(){
  lp.set(parseInt(this.stepCount.value),parseFloat(this.eta.value),
      	 parseFloat(this.sa0.value));
  model.step=0;
};

inherits(LineMap,MapFrame);
inherits(GridMap,MapFrame);
inherits(HexMap,MapFrame);
